//25 11 2003//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// File created with Carad, a CAD source code generator by Martin Waldegger
// Contact the author at martin.waldegger@chello.at or visit
// http://mcad.delphigl.com
//
// This code is distributed in the hope that it will be useful but
// WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
// DISCLAIMED. This includes but is not limited to warranties of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

{$INCLUDE includes.inc}
unit SETHImport;

Interface

uses
  Windows, Messages,
  OpenGL,
  bg,
  SETHImportData;

// the object types

var

// render settings
  DefaultRenderSettings : TRenderSettings;

// texture settings
  DefaultTextureSettings : TTextureSettings;

// texture handles
  DefaultTexture : TTextureDefault;

// material handles
  DefaultMaterial : TMaterial;

// object handles and data
  // handles
  
  // display lists

procedure InitSETHImport;


Implementation

procedure InitSETHImport;

  begin

    // set render settings
    DefaultRenderSettings := NewRenderSettings;
    with DefaultRenderSettings do begin
      Name := 'DefaultRenderSettings';
      SetAlphaTest(csDisable, GL_ALWAYS, 0);
      SetBlendFunc(csDisable, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
      SetColor(true, 1, 1, 1, 1);
      SetColorMask(true, true,true,true,true);
      SetColorMaterial(csDisable, GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
      SetCullFace(csDisable, GL_BACK);
      SetDepthTest(csUpdate, GL_LEQUAL);
      SetDepthWrite(csEnable);
      SetFog(csDisable);
      SetFragmentProgram(csDisable);
      SetLighting(csEnable);
      SetLineSmooth(csDisable);
      SetLineStipple(csDisable, 1, $FFFF);
      SetLineWidth(true, 1);
      SetNormalize(csDisable);
      SetPointParam(true, 0, 1, 1, 1, 0, 0);
      SetPointSize(true, 1);
      SetPointSmooth(csDisable);
      SetPolyMode(true, GL_FILL, GL_FILL);
      SetPolySmooth(csDisable);
      SetPolyStippleState(csDisable);
      SetRescaleNormal(csDisable);
      SetSeparateColor(csEnable);
      SetSmoothShading(csEnable);
      SetStencilTest(csDisable, GL_ALWAYS, 255, $7FFFFFFF, GL_KEEP, GL_KEEP, GL_KEEP);
      SetTwoSided(csDisable);
      SetVertexProgram(csDisable);
    end;

    // set texture settings
    DefaultTextureSettings := NewTextureSettings;
    with DefaultTextureSettings do begin
      Name := 'DefaultTextureSettings';
      {$IFDEF GL_13} SetTexActive(true, GL_TEXTURE0); {$ENDIF}
      SetTexture1D(csEnable);
      SetTexture2D(csEnable);
      SetTexture3D(csDisable);
      SetTextureCubemap(csDisable);
      SetTexEnv(true, GL_MODULATE, 0, 0, 0, 0);
      SetTexGenS(csDisable, GL_EYE_LINEAR, 1, 0, 0, 0);
      SetTexGenT(csDisable, GL_EYE_LINEAR, 0, 1, 0, 0);
      SetTexGenR(csDisable, GL_EYE_LINEAR, 0, 0, 0, 0);
      SetTexGenQ(csDisable, GL_EYE_LINEAR, 0, 0, 0, 0);
      SetTexReflect(csDisable);
    end;

    // initialize texture handle variables
    DefaultTexture := NewTextureDefault;

    // set materials
    DefaultMaterial := NewMaterial;
    with DefaultMaterial do begin
      Name := 'DefaultMaterial';
      SetShininess(0, true);
      SetAmbient(0.2, 0.2, 0.2, 1, true);
      SetDiffuse(0.8, 0.8, 0.8, 1, true);
      SetSpecular(0, 0, 0, 1, true);
      SetEmission(0, 0, 0, 1, true);
      SetFace(GL_FRONT);
    end;

    // set up OpenGL environment
    glClearColor(0.5, 0.5, 0.5, 0); // set background to specified color
    glClearDepth(1.0);       // enable clearing of the depth buffer
    glDepthFunc(GL_LESS);    // the type of depth test to do);
    glEnable(GL_DEPTH_TEST); // enable depth testing);
    glEnable(GL_LIGHTING);   // enable enlightment);
    glShadeModel(GL_SMOOTH); // smooth color shading
    glEnable(GL_TEXTURE_2D); // enable texture mapping

    // setting up light source 0
    LightEnable(0);
    LightDirection(0, 0, 0, 1);
    LightAmbient(0, 0, 0, 0, 1);
    LightDiffuse(0, 1, 1, 1, 1);
    LightSpecular(0, 1, 1, 1, 1);
    LightSpecular(0, 1, 1, 1, 1);
    LightShadow(0, 0, 0, 0, 0.5);
    bgLight[0].Shadowing := true;

    // perspective and viewer orientation
    ViewPerspective(45, 1, 1, 255);
    ViewSet(0, -5, -20,  15, 0, 0);

  end;



end.
